/*
 *	This file is for a Silicon Graphics 4D series machines
 *  Running IRIX 3.1 or 3.2.  (HAVE_JOBCTRL should only be
 *	defined if you have 3.2)
 */


/*
 *	Include header files containing the following definitions:
 *
 * 		off_t, time_t, struct stat
 */

#include <sys/types.h>
#include <sys/stat.h>

/*
 *	Define if your system has system V like ioctls
 */

#define	HAVE_TERMIO			/* */

/*
 *	Define to use terminfo database.
 *	Otherwise, termcap is used
 */

#define	USE_TERMINFO			/* */

/*
 *	Specify the library containing the termcap/terminfo access routines.
 *	Notice:  nn does not use curses.
 *	Notice:  You must also specify whether termcap or terminfo is
 *		 used when you edit config.h (see below).
 */

#define	TERMLIB -lcurses

/*
 *	Define HAVE_STRCHR if strchr() and strrchr() are available
 */

#define HAVE_STRCHR			/* */

/*
 *	Define if a signal handler has type void (see signal.h)
 */

#define	SIGNAL_HANDLERS_ARE_VOID	/* */

/*
 *	Define if signals must be set again after they are caught
 */

#define	RESET_SIGNAL_WHEN_CAUGHT	/* */

/*
 *	Define MICRO_ALARM to timeout in 0.1 seconds if possible
 */

#define MICRO_ALARM()	alarm(1)	/* System V */

/*
 *	Define if your system has BSD like job control (SIGTSTP works)
 */

#define HAVE_JOBCONTROL			/* */

/*
 *	Define if your system has a 4.3BSD like syslog library.
 */

#define HAVE_SYSLOG

/*
 *	Define if your system provides the "directory(3X)" access routines
 *
 *	If true, include the header file(s) required by the package below
 *	(remember that <sys/types.h> or equivalent is included above)
 *	Also typedef Direntry to the proper struct type.
 */

#define	HAVE_DIRECTORY			/* */

#include <dirent.h>			/* System V */

typedef struct dirent Direntry;		/* System V */

/*
 *	Define if your system has a mkdir() library routine
 */

#define	HAVE_MKDIR			/* */

/*
 *	Define HAVE_GETHOSTNAME if your system provides a BSD like 
 *	gethostname routine.
 *	Otherwise, define HAVE_UNAME if uname() is avaiable.
 *	As a final resort, define HOSTNAME to the name of your system.
 */

#define	HAVE_GETHOSTNAME			/* System V */

/*
 *	Define DETATCH_TERMINAL to be a command sequence which 
 *	will detatch a process from the control terminal
 *	Also include files needed to perform this HERE.
 *	If not possible, just define it (empty)
 */

#define	DETATCH_TERMINAL setpgrp();	/* System V */

/* 
 *	Specify where the Bourne Shell is.
 */

#define SHELL		"/bin/sh"

/*
 *	Specify the default mailer to be invoked by nnmail
 */

#define	MAILX		"/usr/bsd/Mail"

/*
 *	Specify the default pager & options.
 */

#define	PAGER		"more"

/*
 *	Specify the default print command and options.
 */

#define	PRINTER		"lp -s"

/*
 *	Define standard compiler flags here:
 */

#define COMPILER_FLAGS -O -I/usr/include/bsd


/*
 *	Define the maximum length of any pathname that may occur
 */

#define	FILENAME 	1024	/* really should be from limits.h */

/*
 *	If your system requires other libraries when linking nn
 *	specify them here:  (use shared C library for reduced
 *	size and portability across releases).
 */

#define EXTRA_LIB -lbsd -lc_s
